/*-
 *
 * Copyright (c) 1999 Neil Blakey-Milner
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: lists.h,v 1.4 1999/07/28 16:37:26 nbm Exp $
 *
 */

#include <sys/queue.h>

LIST_HEAD           (, classList) chead;
struct classList {
	char               *name;
	char               *description;
	char               *options;
	char              **options_array;
	void               *widget;
	LIST_ENTRY          (classList) entries;	/* List */
};

LIST_HEAD           (, optionList) ohead;
struct optionList {
	char               *name;
	char               *description;
	char               *content;
	char               *depends;
	char              **depends_array;
	int                 enabled;
	void               *widget;
	LIST_ENTRY          (optionList) entries;
};

struct _olookup {
	char               *name;
	struct optionList  *ol;
}                 **olookup;

struct _clookup {
	char               *name;
	struct classList   *cl;
}                 **clookup;

unsigned short int  numclasses;
unsigned short int  numoptions;

struct targetList {
	char               *target;
	LIST_HEAD           (, subtList) list;
	LIST_ENTRY          (targetList) entries;
};

struct subtList {
	char               *name;
	LIST_ENTRY          (subtList) entries;
};

void                build_lookup(void);
void                free_lookups(void);
void                get_depends(struct optionList *, char *);
void                get_class_options(struct classList *, char *);

void                write_makefile();
struct optionList  *lookup_options(char *);
struct classList   *lookup_class(char *);
